package com.steerinfo.baseinfo.meterbasecalibrationnum.controller;

import com.steerinfo.baseinfo.meterbasecalibrationtime.model.MeterBaseCalibrationTime;
import com.steerinfo.framework.controller.BaseRESTfulController;
import com.steerinfo.framework.controller.RESTfulResult;
import com.steerinfo.framework.service.pagehelper.PageList;
import com.steerinfo.framework.utils.collection.ListUtils;
import com.steerinfo.baseinfo.meterbasecalibrationnum.model.MeterBaseCalibrationNum;
import com.steerinfo.baseinfo.meterbasecalibrationnum.service.IMeterBaseCalibrationNumService;
import com.steerinfo.meterwork.except.MarkerMetException;
import com.steerinfo.util.StringUtils;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.transaction.interceptor.TransactionAspectSupport;
import org.springframework.web.bind.annotation.*;

import java.util.Arrays;
import java.util.HashMap;
import java.util.List;
import java.util.ArrayList;

/**
 * MeterBaseCalibrationNum RESTful接口：
 *
 * @author generator
 * @version 1.0-SNAPSHORT 2020-06-28 03:17
 * 类描述
 * 修订历史：
 * 日期：2020-06-28
 * 作者：generator
 * 参考：
 * 描述：MeterBaseCalibrationNum RESTful接口
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 * @see null
 */
@RestController
@RequestMapping("/${api.version}/meterbasecalibrationnums")
@Api(value = "/${api.version}/meterbasecalibrationnums", tags = "校秤计量配置 - MeterBaseCalibrationNumController")
public class MeterBaseCalibrationNumController extends BaseRESTfulController {

    @Autowired
    IMeterBaseCalibrationNumService meterBaseCalibrationNumService;

    @ApiOperation(value = "获取列表", notes = "分页查询")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("meterbasecalibrationnum:view")
    @GetMapping(value = "/")
    public RESTfulResult list(@RequestParam HashMap parmas, Integer pageNum, Integer pageSize) {
        try {
            PageList<MeterBaseCalibrationNum> list = meterBaseCalibrationNumService.queryForPage(parmas, pageNum, pageSize);
            return success(list);
        } catch (Exception ex) {
           ex.printStackTrace();
throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "获取列表", notes = "分页模糊查询")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("meterbasecalibrationnum:view")
    @GetMapping(value = "/like/")
    public RESTfulResult listLike(@RequestParam HashMap parmas, Integer pageNum, Integer pageSize) {
        try {
            PageList<MeterBaseCalibrationNum> list = meterBaseCalibrationNumService.queryLikeForPage(parmas, pageNum, pageSize);
            return success(list);
        } catch (Exception ex) {
           ex.printStackTrace();
throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "创建", notes = "根据MeterBaseCalibrationNum对象创建")
    @ApiImplicitParam(name = "meterBaseCalibrationNum", value = "详细实体meterBaseCalibrationNum", required = true, dataType = "MeterBaseCalibrationNum")
    //@RequiresPermissions("meterbasecalibrationnum:create")
    @Transactional
    @PostMapping(value = "/")
    public RESTfulResult add(@RequestBody MeterBaseCalibrationNum model) {
        try {
            String msg = meterBaseCalibrationNumService.checkandadd(model);
            if (StringUtils.isNotEmpty(msg)) {
                return failed(null, msg);
            }
        } catch (Exception e) {
            e.printStackTrace();
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            return failed(null, "操作异常，请确认！"+e.getMessage());
        }

        return success();
    }

    @ApiOperation(value = "获取详细信息", notes = "根据url的id来获取详细信息")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("meterbasecalibrationnum:view")
    @GetMapping(value = "/{id}")
    public RESTfulResult get(@PathVariable String id) {
        try {
            MeterBaseCalibrationNum meterBaseCalibrationNum = meterBaseCalibrationNumService.getById(id);
            return success(meterBaseCalibrationNum);
        } catch (Exception ex) {
           ex.printStackTrace();
throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "更新详细信息", notes = "根据url的id来指定更新对象，并根据传过来的meterBaseCalibrationNum信息来更新详细信息")
    @ApiImplicitParams({
            @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String"),
            @ApiImplicitParam(name = "meterBaseCalibrationNum", value = "详细实体meterBaseCalibrationNum", required = true, dataType = "MeterBaseCalibrationNum")
    })
    //@RequiresPermissions("meterbasecalibrationnum:update")
    @Transactional
    @PutMapping(value = "/{id}", produces = "application/json;charset=UTF-8")
    public RESTfulResult update(@PathVariable String id, @RequestBody MeterBaseCalibrationNum model) {
        try {
            String msg = meterBaseCalibrationNumService.checkandupdate(id, model);
            if (StringUtils.isNotEmpty(msg)) {
                return failed(null, msg);
            }
        } catch (Exception e) {
            e.printStackTrace();
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            return failed(null, "操作异常，请确认！"+e.getMessage());
        }

        return success();
    }

    @ApiOperation(value = "删除", notes = "根据url的id来指定删除对象")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("meterbasecalibrationnum:delete")
    @DeleteMapping(value = "/{id}")//String
    public RESTfulResult delete(@PathVariable String id) {
        List<String> list = Arrays.asList(id.split(","));
        if (ListUtils.isNotEmpty(list)) {
            List<String> ids = ListUtils.convertList(list);
            meterBaseCalibrationNumService.delete(ids);
        }
        return success();
    }

    @ApiOperation(value = "批量删除", notes = "根据url的MeterBaseCalibrationNum来指定删除对象")
    @ApiImplicitParam(name = "meterBaseCalibrationNum", value = "详细实体meterBaseCalibrationNum", required = true, dataType = "MeterBaseCalibrationNum")
    //@RequiresPermissions("meterbasecalibrationtime:delete")
    @PutMapping(value = "/")
    public RESTfulResult delete(@RequestBody List<MeterBaseCalibrationNum> models) {
        List<String> list = new ArrayList<String>();
        for (MeterBaseCalibrationNum model : models) {
            String id = model.getId();
            list.add(id);
        }
        List<String> ids = ListUtils.convertList(list);
        meterBaseCalibrationNumService.delete(ids);
        return success();
    }

    @ApiOperation(value = "启用标识符", notes = "根据传过来的MeterBaseCalibrationNum集合信息来更新详细信息")
    @Transactional
    @PostMapping(value = "/Recovery")
    public RESTfulResult recovery(@RequestBody List<MeterBaseCalibrationNum> models) {
        try {
            String msg = meterBaseCalibrationNumService.recovery(models);
            if (StringUtils.isNotEmpty(msg)) {
                return failed(null, msg);
            }
        } catch (Exception e) {
            e.printStackTrace();
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            return failed(null, "操作异常，请确认！");
        }
        return success();
    }

    @ApiOperation(value = "废除标识符", notes = "根据传过来的MeterBaseCalibrationNum集合信息来更新详细信息")
    @ApiImplicitParams({

            @ApiImplicitParam(name = "MeterBaseCalibrationNum", value = "详细实体MeterBaseCalibrationNum", required = true, dataType = "MeterBaseCalibrationNum")
    })
    //@RequiresPermissions("combaseinfo:update")
    @Transactional
    @PostMapping(value = "/abolish")
    public RESTfulResult abolish(@RequestBody List<MeterBaseCalibrationNum> models) {
        try {
            String msg = meterBaseCalibrationNumService.abolish(models);
            if (StringUtils.isNotEmpty(msg)) {
                return failed(null, msg);
            }
        } catch (Exception e) {
            e.printStackTrace();
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            return failed(null, "操作异常，请确认！");
        }
        return success();
    }

    @ApiOperation(value = "按校称重量编号修改校称重量数据使用状态", notes = "根据传过来的MeterBaseCalibrationNum集合信息来更新详细信息")
    @Transactional
    @PostMapping(value = "/updateStateByPrimaryKey")
    public RESTfulResult updateStateByPrimaryKey(@RequestParam(required = true) String mbCalibNumNo,@RequestParam(required = true) String flag) {
        try {
            String msg = meterBaseCalibrationNumService.updateStateByPrimaryKey(mbCalibNumNo,flag);
            if (StringUtils.isNotEmpty(msg)) {
                return failed(null, msg);
            }
        } catch (Exception e) {
            e.printStackTrace();
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            return failed(null, "操作异常，请确认！");
        }
        return success();
    }
}
